VCPHP网站模板 - 外贸网站建设,外贸网站模板

VCPHP网站模板

当前位置: 首页 > WordPress > WordPress教程 >

解决WordPress插件冲突的办法

时间:2014-05-26 23:38来源:未知 作者:VCPHP网站模板 点击:
首先,我们要引入一个Wordpress核心文件: /*避免current_user_can不可用的问题*/ if (!function_exists(wp_get_current_user)){ if (! file_exists (ABSPATH.wp-includes/pluggable.php)) require_once (ABSPATH.wp-includes/pluggable.php); requi

首先,我们要引入一个Wordpress核心文件:

  1. /*  避免 current_user_can 不可用的问题 */
  2. if ( !function_exists( 'wp_get_current_user' ) ) {
  3.  
  4.     if ( !file_exists(ABSPATH.'wp-includes/pluggable.php') ) require_once( ABSPATH.'wp-includes/pluggable.php' );
  5.  
  6.     require_once( ABSPATH . 'wp-admin/includes/plugin.php' );
  7.  
  8. }

然后,我们需要在插件中定义Wordpress后台初始化Hook函数,以禁用插件自身,以免网站报错,在这个函数中,我们需要判断当前用户是否可以启用插件,如果可以,那么与该插件冲突的插件是否已经被启用了,如果与该插件冲突的插件被启用了,就报个错误,禁用自身,如果与该插件冲突的是一个该插件的Lite版本,那么可以干脆的禁用掉它,下面以自制插件WP Youku(相当于Lite版本)和WP Youku Pro(相当于Pro版本)来说明问题:
在插件WP Youku中写:

  1. add_action( 'admin_init', 'wp_youku_deactivate' );
  2. function wp_youku_deactivate() {
  3.  
  4.     if ( current_user_can( 'activate_plugins' ) ) {
  5.         if( is_plugin_active( 'wp-youku-pro/wp-youku-pro.php' ) ) {
  6.             add_action( 'admin_notices', 'wp_youku_admin_notice' );
  7.             deactivate_plugins( plugin_basename( __FILE__ ) );
  8.             /*在Lite版本的插件中禁用掉Pro版本的插件是不合适的,所以下面我注释掉了*/
  9.             //deactivate_plugins('wp-youku-pro/wp-youku-pro.php');
  10.         }
  11.     }
  12.  
  13. }
  14.  
  15.  
  16. function wp_youku_admin_notice() {
  17.  
  18.    echo '<div class="error"><p><strong>WP Youku</strong> 未能启用,可能的原因是您已经启用了<strong>WP Youku Pro</strong>.</p></div>';
  19.    /*进一步确认不可启用自身*/
  20.    //if ( isset( $_GET['activate'] ) ) unset( $_GET['activate'] );
  21.  
  22. }

在插件WP Youku Pro中写:

  1. add_action( 'admin_init', 'wp_youku_pro_deactivate' );
  2. function wp_youku_pro_deactivate() {
  3.  
  4.     if ( current_user_can( 'activate_plugins' ) ) {
  5.         if( is_plugin_active( 'wp-youku/wp-youku.php' ) ) {
  6.              add_action( 'admin_notices', 'wp_youku_pro_admin_notice' );
  7.             /*禁用该插件对应的Lite版本*/
  8.             deactivate_plugins('wp-youku/wp-youku.php' );
  9.             /*是否禁用自身?作为Pro版插件,在与对应的Lite版冲突的时候,大可不必禁用自身,所以下面注释掉了,当然,也可以加上许可证检查步骤以确定是否禁用掉自身*/
  10.             //deactivate_plugins( plugin_basename( __FILE__ ) );
  11.         }
  12.     }
  13.  
  14. }
  15.  
  16. function wp_youku_pro_admin_notice() {
  17.  
  18.   echo '<div class="error"><p>检测到您已经启用了<strong>WP Youku</strong>, <strong>WP Youku Pro</strong>已经禁用了它,请刷新本页面.</p></div>';
  19.   //可以启用自身
  20.   if ( isset( $_GET['activate'] ) ) unset( $_GET['activate'] );
  21.  
  22. }

 

 

这样,在先启用Lite版本,后启用Pro版本的时候,会在自动启用Pro版本并禁用自身之后给出提示;在先启用Pro版本,后启用Lite版本的时候,Lite版本的启用动作将是无效的,并给出一个提示:

Wordpress插件冲突的解决办法

WordPress插件冲突的解决办法

以上是针对类型的Wordpress插件冲突的解决方案,如果是一般性的插件冲突,最后在禁用自身后给出友好的提示即可。

(责任编辑:VCPHP网站模板)
顶一下
(0)
0%
踩一下
(0)
0%
------分隔线----------------------------
发表评论
请自觉遵守互联网相关的政策法规,严禁发布色情、暴力、反动的言论。
评价:
验证码: 点击我更换图片
栏目列表
推荐内容
 
QQ在线咨询
售前电话热线
400-083-8184
售前QQ客服